diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_gline.c1 PleXusIRCd-1.17a/modules/m_gline.c1
--- ircd-hybrid-7.0/modules/m_gline.c1	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_gline.c1	Mon Sep  8 21:10:37 2003
@@ -0,0 +1,625 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_gline.c: Votes towards globally banning a mask.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_gline.c,v 1.1 2003/04/07 08:46:52 morpheus66 Exp $
+ */
+
+#include "stdinc.h"
+#include "tools.h"
+#include "handlers.h"
+#include "s_gline.h"
+#include "channel.h"
+#include "client.h"
+#include "common.h"
+#include "config.h"
+#include "irc_string.h"
+#include "ircd.h"
+#include "hostmask.h"
+#include "numeric.h"
+#include "fdlist.h"
+#include "s_bsd.h"
+#include "s_conf.h"
+#include "s_misc.h"
+#include "scache.h"
+#include "send.h"
+#include "msg.h"
+#include "fileio.h"
+#include "s_serv.h"
+#include "hash.h"
+#include "parse.h"
+#include "modules.h"
+#include "list.h"
+
+#define GLINE_NOT_PLACED 0
+#define GLINE_ALREADY_VOTED -1
+#define GLINE_PLACED 1
+
+/* internal functions */
+static void set_local_gline(
+                            const char *oper_nick,
+                            const char *oper_user,
+                            const char *oper_host,
+                            const char *oper_server,
+                            const char *user,
+                            const char *host,
+                            const char *reason);
+
+static void log_gline_request(const char*,const char*,const char*,
+                              const char* oper_server,
+                              const char *,const char *,const char *);
+
+static void log_gline(struct Client *,
+                      const char *, const char *,const char *,
+                      const char* oper_server,
+                      const char *,const char *,const char *);
+
+
+static void trigger_gline(struct Client *source_p,
+                                 const char *oper_nick,
+                                 const char *oper_user,
+                                 const char *oper_host,
+                                 const char *oper_server,
+                                 const char *user, const char *host,
+                                 const char *reason);
+
+static int check_wild_gline(char *, char *);
+static int invalid_gline(struct Client *, char *, char *, char *);
+		       
+static void ms_gline(struct Client*, struct Client*, int, char**);
+static void mo_gline(struct Client*, struct Client*, int, char**);
+
+struct Message gline_msgtab = {
+    "GLINE", 0, 0, 3, 0, MFLG_SLOW, 0,
+      {m_unregistered, m_not_oper, ms_gline, m_ignore}
+};
+
+#ifndef STATIC_MODULES
+
+void
+_modinit(void)
+{
+    mod_add_cmd(&gline_msgtab);
+}
+
+void
+_moddeinit(void)
+{
+  mod_del_cmd(&gline_msgtab);
+}
+
+const char *_version = "$Revision: 1.1 $";
+#endif
+/*
+ * mo_gline()
+ *
+ * inputs       - The usual for a m_ function
+ * output       -
+ * side effects -
+ *
+ * Place a G line if 3 opers agree on the identical user@host
+ * 
+ */
+/* Allow this server to pass along GLINE if received and
+ * GLINES is not defined.
+ *
+ */
+
+static void
+mo_gline(struct Client *client_p, struct Client *source_p,
+	 int parc, char *parv[])
+{
+  char *user = NULL;
+  char *host = NULL;	              /* user and host of GLINE "victim" */
+  const char *reason = NULL;          /* reason for "victims" demise */
+  char tempuser[USERLEN + 2];
+  char temphost[HOSTLEN + 1];
+
+  if (!ConfigFileEntry.glines)
+    {
+    sendto_one(source_p,":%s NOTICE %s :GLINE disabled",me.name,parv[0]);  
+    return;
+  }
+
+      if (!IsOperGline(source_p))
+	{
+	  sendto_one(source_p,
+		     ":%s NOTICE %s :You need gline = yes;",me.name,parv[0]);
+	  return;
+	}
+			
+  if ((host = strchr(parv[1], '@')) || *parv[1] == '*')
+	{
+	  /* Explicit user@host mask given */
+	      
+	  if(host != NULL)	/* Found user@host */
+	    {
+	      user = parv[1];   /* here is user part */
+	      *(host++) = '\0'; /* and now here is host */
+
+              /* gline for "@host", use *@host */
+              if(*user == '\0')
+                user = "*";
+	    }
+	  else
+	    {
+	      user = "*";               /* no @ found, assume its *@somehost */
+	      host = parv[1];
+	    }
+	      
+    if (*host == '\0')	/* duh. no host found, assume its '*' host */
+	    host = "*";
+	      
+	  strlcpy(tempuser, user, USERLEN + 1);     /* allow for '*' */
+	  strlcpy(temphost, host, HOSTLEN + 1);
+	  user = tempuser;
+	  host = temphost;
+	}
+      else
+	{
+	  sendto_one(source_p,
+		     ":%s NOTICE %s :Can't G-Line a nick use user@host",
+		     me.name, parv[0]);
+	  return;
+	}
+
+      if(invalid_gline(source_p, user, host, parv[2]))
+        return;
+			
+      /* Not enough non-wild characters were found,
+       * assume they are trying to gline *@*.
+       */
+
+      if (check_wild_gline(user, host))
+	{
+	  if (MyClient(source_p))
+	    sendto_one(source_p,
+		       ":%s NOTICE %s :Please include at least %d non-wildcard characters with the user@host",
+		       me.name, parv[0], ConfigFileEntry.min_nonwildcard);
+	  return;
+	}
+			
+      reason = parv[2];
+
+      /* inform users about the gline before we call trigger_gline()
+       * so already voted comes below gline request --fl
+       */
+      log_gline_request(source_p->name,
+                        (const char *)source_p->username,
+                        source_p->host,me.name, user, host, reason);
+
+      /* Good gline, trigger it */
+      trigger_gline(source_p,
+			   source_p->name,
+			   (const char *)source_p->username,
+			   source_p->host, me.name, user, host, reason);
+
+      /* 4 param version for hyb-7 servers */
+      sendto_server(NULL, source_p, NULL, CAP_GLN|CAP_UID, NOCAPS,
+                    LL_ICLIENT,
+                    ":%s GLINE %s %s :%s",
+                    ID(source_p), user, host, reason);
+      sendto_server(NULL, source_p, NULL, CAP_GLN, CAP_UID,
+                    LL_ICLIENT,
+                    ":%s GLINE %s %s :%s",
+                    source_p->name, user, host, reason);
+
+      /* 8 param for hyb-6 */
+      sendto_server(NULL, NULL, NULL, CAP_UID, CAP_GLN, NOFLAGS,
+                    ":%s GLINE %s %s %s %s %s %s :%s",
+                    me.name, ID(source_p), source_p->username,
+                    source_p->host, source_p->user->server, user, host,
+                    reason);
+      sendto_server(NULL, NULL, NULL, NOCAPS, CAP_GLN|CAP_UID, NOFLAGS,
+                    ":%s GLINE %s %s %s %s %s %s :%s",
+                    me.name, source_p->name, source_p->username,
+                    source_p->host, source_p->user->server, user, host,
+                    reason);
+}
+
+/*
+ * ms_gline()
+ *
+ * inputs       - The usual for a m_ function
+ * output       -
+ * side effects -
+ *
+ * Place a G line if 3 opers agree on the identical user@host
+ * 
+ */
+/* Allow this server to pass along GLINE if received and
+ * GLINES is not defined.
+ */
+
+static void
+ms_gline(struct Client *client_p, struct Client *source_p,
+	 int parc, char *parv[])
+{
+  /* These are needed for hyb6 compatibility.. if its ever removed we can
+   * just use source_p->username etc.. 
+   */
+  const char *oper_nick = NULL;        /* nick of oper requesting GLINE */
+  const char *oper_user = NULL;        /* username of oper requesting GLINE */
+  const char *oper_host = NULL;        /* hostname of oper requesting GLINE */
+  const char *oper_server = NULL;      /* server of oper requesting GLINE */
+  char *user = NULL;
+  char *host = NULL;             /* user and host of GLINE "victim" */
+  const char *reason = NULL;           /* reason for "victims" demise */
+  struct Client *acptr;
+
+  /* hyb-7 style gline (post beta3) */
+  if(parc == 4 && IsPerson(source_p))
+    {
+      oper_nick = parv[0];
+      oper_user = source_p->username;
+      oper_host = source_p->host;
+      oper_server = source_p->user->server;
+      user = parv[1];
+      host = parv[2];
+      reason = parv[3];
+    }
+  /* or it's a hyb-6 style */
+  else if(parc == 8 && IsServer(source_p))
+    {
+      oper_nick = parv[1];
+      oper_user = parv[2];
+      oper_host = parv[3];
+      oper_server = parv[4];
+      user = parv[5];
+      host = parv[6];
+      reason = parv[7];      
+    }
+  /* none of the above */
+  else
+    return;
+
+  /* Its plausible that the server and/or client dont actually exist,
+   * and its faked, as the oper isnt sending the gline..
+   * check they're real --fl_ */
+  /* we need acptr for LL introduction anyway -davidt */
+  if((acptr = find_server(oper_server)))
+  {
+    if((acptr = find_client(oper_nick)) == NULL)
+      return;
+  }
+  else
+    return;
+
+ if(invalid_gline(acptr, user, host, (char *)reason))
+    return;
+    
+  /* send in hyb-7 to compatible servers */
+  sendto_server(client_p, acptr, NULL, CAP_GLN, NOCAPS, LL_ICLIENT,
+                ":%s GLINE %s %s :%s",
+                oper_nick, user, host, reason);
+  /* hyb-6 version to the rest */
+  sendto_server(client_p, NULL, NULL, NOCAPS, CAP_GLN, NOFLAGS,
+                ":%s GLINE %s %s %s %s %s %s :%s",
+                oper_server, oper_nick, oper_user, oper_host,
+                oper_server, user, host, reason);
+
+  if (ConfigFileEntry.glines)
+    {
+     /* I dont like the idea of checking for x non-wildcard chars in a
+      * gline.. it could lead to a desync... but we have to stop people
+      * glining *@*..   -- fl
+      */
+
+     if (check_wild_gline(user, host))
+        {
+          sendto_realops_flags(FLAGS_ALL, L_ALL, 
+                       "%s!%s@%s on %s is requesting a gline without %d non-wildcard characters for [%s@%s] [%s]",
+                       oper_nick, oper_user, oper_host, oper_server, ConfigFileEntry.min_nonwildcard,
+                       user, host, reason);
+          return;
+        }
+
+      log_gline_request(oper_nick,oper_user,oper_host,oper_server,
+			user,host,reason);
+
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+			   "%s!%s@%s on %s is requesting gline for [%s@%s] [%s]",
+			   oper_nick, oper_user, oper_host, oper_server,
+			   user, host, reason);
+
+      /* Good gline, trigger it */
+      trigger_gline(source_p, oper_nick, oper_user, oper_host,
+			   oper_server, user, host, reason);
+    }
+}
+
+/*
+ * check_wild_gline
+ *
+ * inputs       - user, host of gline
+ * output       - 1 if not enough non-wildchar char's, 0 if ok
+ * side effects - NONE
+ */
+
+static int
+check_wild_gline(char *user, char *host)
+{
+  char *p;
+  char tmpch;
+  int nonwild;
+
+  nonwild = 0;
+  p = user;
+
+  while ((tmpch = *p++))
+    {
+       if (!IsKWildChar(tmpch))
+         {
+            /*
+             * If we find enough non-wild characters, we can
+             * break - no point in searching further.
+             */
+            if (++nonwild >= ConfigFileEntry.min_nonwildcard)
+              break;
+         }
+    }
+
+   if (nonwild < ConfigFileEntry.min_nonwildcard)
+    {
+       /*
+        * The user portion did not contain enough non-wild
+        * characters, try the host.
+        */
+       p = host;
+       while ((tmpch = *p++))
+         {
+           if (!IsKWildChar(tmpch))
+             if (++nonwild >= ConfigFileEntry.min_nonwildcard)
+               break;
+         }
+     }
+
+    if (nonwild < ConfigFileEntry.min_nonwildcard)
+       return 1;
+    else
+       return 0;
+}
+
+/* invalid_gline
+ *
+ * inputs	- pointer to source client
+ *		- pointer to ident
+ *		- pointer to host
+ *		- pointer to reason
+ * outputs	- 1 if invalid, 0 if valid
+ */
+static int
+invalid_gline(struct Client *source_p, char *luser, char *lhost,
+                       char *lreason)
+{
+  if(strchr(luser, '!'))
+  {
+    sendto_one(source_p, ":%s NOTICE %s :Invalid character '!' in gline",
+               me.name, source_p->name);
+    return 1;
+  }
+
+  return 0;
+}
+
+/*
+ * trigger_gline
+ *
+ * inputs	- pointer to source client
+ * 		- name of operator requesting gline
+ * 		- username of operator requesting gline
+ * 		- hostname of operator requesting gline
+ * 		- servername of operator requesting gline
+ * 		- username covered by the gline
+ * 		- hostname covered by the gline
+ * 		- reason for the gline
+ * output	- NONE
+ */
+static void
+trigger_gline(struct Client *source_p,
+		     const char *oper_nick, const char *oper_user,
+		     const char *oper_host, const char *oper_server,
+		     const char *user, const char *host,
+		     const char *reason)
+{
+
+   /* If it's already glined, do not
+      add the gline. */
+
+   if(find_is_glined(host, user))
+      return;
+
+   set_local_gline(oper_nick, oper_user, oper_host, oper_server,
+                               user, host, reason);
+   cleanup_glines();
+}
+
+/*
+ * set_local_gline
+ *
+ * inputs	- pointer to oper nick
+ * 		- pointer to oper username
+ * 		- pointer to oper host
+ *		- pointer to oper server
+ *		- pointer to victim user
+ *		- pointer to victim host
+ *		- pointer reason
+ * output	- NONE
+ * side effects	-
+ */
+static void
+set_local_gline(const char *oper_nick,
+                            const char *oper_user,
+                            const char *oper_host,
+                            const char *oper_server,
+                            const char *user,
+                            const char *host,
+                            const char *reason)
+{
+  char buffer[IRCD_BUFSIZE];
+  struct ConfItem *aconf;
+  const char *current_date;
+
+  current_date = smalldate((time_t) 0);
+          
+  aconf = make_conf();
+  aconf->status = CONF_KILL;
+
+  ircsprintf(buffer, "%s (%s)",reason,current_date);
+      
+  DupString(aconf->passwd, buffer);
+  DupString(aconf->name, (char *)user);
+  DupString(aconf->host, (char *)host);
+  aconf->hold = CurrentTime + ConfigFileEntry.gline_time;
+  add_gline(aconf);
+      
+  sendto_realops_flags(FLAGS_ALL, L_ALL,
+		       "%s!%s@%s on %s added gline for [%s@%s] (Reason: %s)",
+		       oper_nick, oper_user, oper_host, oper_server,
+		       user, host, reason);
+  check_klines();
+}
+
+
+/*
+ * log_gline_request()
+ *
+ */
+static void
+log_gline_request(
+		  const char *oper_nick, const char *oper_user,
+		  const char *oper_host, const char* oper_server,
+		  const char *user, const char *host, const char *reason)
+{
+  char        buffer[2*BUFSIZE];
+  char        filenamebuf[PATH_MAX + 1];
+  static char timebuffer[MAX_DATE_STRING];
+  struct tm*  tmptr;
+  FBFILE*     out;
+
+  if(ConfigFileEntry.glinefile == NULL)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem opening glinefile");
+      return;
+    }
+
+  ircsprintf(filenamebuf, "%s.%s", 
+             ConfigFileEntry.glinefile, small_file_date((time_t)0));
+  if ( (out = fbopen(filenamebuf, "+a")) == NULL )
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem opening %s: %s",
+                     filenamebuf, strerror(errno));
+      return;
+    }
+
+  tmptr = localtime((const time_t*)&CurrentTime);
+  strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
+
+  ircsprintf(buffer,
+           "#Gline for %s@%s [%s] requested by %s!%s@%s on %s at %s\n",
+           user,host,reason,
+           oper_nick,oper_user,oper_host,oper_server,
+           timebuffer);
+
+  if (fbputs(buffer, out) == -1)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem writing to %s (%s)",
+				     filenamebuf, strerror(errno));
+    }
+  fbclose(out);
+}
+
+/*
+ * log_gline()
+ *
+ */
+static void
+log_gline(struct Client *source_p,
+	  const char *oper_nick, const char *oper_user, const char *oper_host,
+	  const char *oper_server, const char *user, const char *host,
+	  const char *reason)
+{
+  char         buffer[2*BUFSIZE];
+  char         filenamebuf[PATH_MAX + 1];
+  static  char timebuffer[MAX_DATE_STRING + 1];
+  struct tm*   tmptr;
+  FBFILE       *out;
+
+  if(ConfigFileEntry.glinefile == NULL)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem opening glinefile.");
+      return;
+    }
+
+  ircsprintf(filenamebuf, "%s.%s", 
+                ConfigFileEntry.glinefile, small_file_date((time_t) 0));
+
+  if ((out = fbopen(filenamebuf, "a")) == NULL)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+			   "*** Problem opening %s",filenamebuf);
+      return;
+    }
+
+  tmptr = localtime((const time_t*)&CurrentTime);
+  strftime(timebuffer, MAX_DATE_STRING, "%Y/%m/%d %H:%M:%S", tmptr);
+
+  ircsprintf(buffer,"#Gline for %s@%s %s added by the following\n",
+                   user,host,timebuffer);
+
+  if (fbputs(buffer,out) == -1)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,
+			   "*** Problem writing to %s",filenamebuf);
+      fbclose(out);
+      return;
+    }
+
+  ircsprintf(buffer, "#%s!%s@%s on %s [%s]\n",
+                   oper_nick,
+                   oper_user,
+                   oper_host,
+                   oper_server,
+                   (reason)?reason:"No reason");
+
+  if (fbputs(buffer,out) == -1)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem writing to %s",filenamebuf);
+      fbclose(out);
+      return;
+    }
+
+  ircsprintf(buffer, "\"%s\",\"%s\",\"%s %s\",\"%s\",%lu\n",
+	     user,
+	     host,
+	     reason,
+	     timebuffer,
+	     oper_nick,
+	     (unsigned long) CurrentTime);
+
+  if (fbputs(buffer,out) == -1)
+    {
+      sendto_realops_flags(FLAGS_ALL, L_ALL,"*** Problem writing to %s",filenamebuf);
+      fbclose(out);
+      return;
+    }
+
+  fbclose(out);
+}
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_join.c PleXusIRCd-1.17a/modules/m_join.c
--- ircd-hybrid-7.0/modules/m_join.c	Wed Apr  2 20:29:00 2003
+++ PleXusIRCd-1.17a/modules/m_join.c	Mon Jun 16 18:20:22 2003
@@ -365,7 +365,7 @@
 	   */
 	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
 			       source_p->name, source_p->username,
-			       source_p->host, root_chptr->chname);
+			       source_p->vhost, root_chptr->chname);
       
 	  sendto_channel_local(ONLY_CHANOPS_HALFOPS,chptr,
 			       ":%s MODE %s %s %s",
@@ -382,7 +382,7 @@
 
 	  sendto_channel_local(ALL_MEMBERS, chptr, ":%s!%s@%s JOIN :%s",
 			       source_p->name, source_p->username,
-			       source_p->host, root_chptr->chname);
+			       source_p->vhost, root_chptr->chname);
         }
 
 
@@ -493,7 +493,7 @@
 
       sendto_channel_local(ALL_MEMBERS,chptr, ":%s!%s@%s PART %s",
 			   source_p->name, source_p->username,
-			   source_p->host, RootChan(chptr)->chname);
+			   source_p->vhost, RootChan(chptr)->chname);
       remove_user_from_channel(chptr, source_p);
     }
 }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_kline.c PleXusIRCd-1.17a/modules/m_kline.c
--- ircd-hybrid-7.0/modules/m_kline.c	Wed Nov 13 08:12:02 2002
+++ PleXusIRCd-1.17a/modules/m_kline.c	Sun Nov 30 04:37:03 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: m_kline.c,v 1.111 2002/11/13 13:12:02 db Exp $
+ *  $Id: m_kline.c,v 1.12 2003/11/30 13:12:02 Static Exp $
  */
 
 #include "stdinc.h"
@@ -75,7 +75,7 @@
   mod_del_cmd(&kline_msgtab);
   mod_del_cmd(&dline_msgtab);
 }
-const char *_version = "$Revision: 1.111 $";
+const char *_version = "$Revision: 1.12 $";
 #endif
 
 /* Local function prototypes */
@@ -288,7 +288,7 @@
   if (!match(parv[1],me.name))
     return;
 
-  if (!IsPerson(source_p))
+  if (!IsPerson(source_p)) 
     return;
 
   if (valid_user_host(source_p, kuser, khost))
@@ -317,12 +317,6 @@
   if (find_u_conf((char *)source_p->user->server,
 		  source_p->username, source_p->host))
     {
-      sendto_realops_flags(FLAGS_ALL, L_ALL,
-			   "*** Received K-Line for [%s@%s] [%s], from %s!%s@%s on %s",
-			   kuser, khost, kreason,
-			   source_p->name, source_p->username,
-			   source_p->host, source_p->user->server);
-
       /* We check if the kline already exists after we've announced its 
        * arrived, to avoid confusing opers - fl
        */
@@ -381,6 +375,8 @@
 {
   aconf->hold = CurrentTime + tkline_time;
   add_temp_kline(aconf);
+  //ADDED HERE TEST!!! STATIC
+  if (strcmp("OperServ", source_p->name)) {
   sendto_realops_flags(FLAGS_ALL, L_ALL,
 		       "%s added temporary %d min. K-Line for [%s@%s] [%s]",
 		       get_oper_name(source_p), tkline_time/60,
@@ -389,6 +385,7 @@
   sendto_one(source_p, ":%s NOTICE %s :Added temporary %d min. K-Line [%s@%s]",
 	     me.name, source_p->name, tkline_time/60,
 	     aconf->user, aconf->host);
+  }
   ilog(L_TRACE, "%s added temporary %d min. K-Line for [%s@%s] [%s]",
        source_p->name, tkline_time/60,
        aconf->user, aconf->host, aconf->passwd);
@@ -985,19 +982,6 @@
   {
    reason = aconf->passwd ? aconf->passwd : "<No Reason>";
 
-   /* Remote servers can set klines, so if its a dupe we warn all 
-    * local opers and leave it at that
-    */
-   /* they can?  here was me thinking it was only remote clients :P */
-   if(!MyClient(source_p))
-    sendto_realops_flags(FLAGS_ALL, L_ALL, 
-             "*** Remote K-Line [%s@%s] already K-Lined by [%s@%s] - %s",
-             luser, lhost, aconf->user, aconf->host, reason);
-   else
-    sendto_one(source_p,
-             ":%s NOTICE %s :[%s@%s] already K-Lined by [%s@%s] - %s",
-              me.name, source_p->name, luser, lhost, aconf->user,
-              aconf->host, reason);
      return 1;
   }
  }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_knock.c PleXusIRCd-1.17a/modules/m_knock.c
--- ircd-hybrid-7.0/modules/m_knock.c	Thu Sep  5 02:05:40 2002
+++ PleXusIRCd-1.17a/modules/m_knock.c	Mon Jun 16 18:18:34 2003
@@ -54,7 +54,7 @@
 
 static int is_banned_knock(struct Channel *, struct Client *, char *);
 static int check_banned_knock(struct Channel *, struct Client *,
-                              char *, char *);
+                              char *, char *, char *);
 
 struct Message knock_msgtab = {
   "KNOCK", 0, 0, 2, 0, MFLG_SLOW, 0,
@@ -415,7 +415,7 @@
   			     chptr, form_str(RPL_KNOCK),
 			     me.name, name, name,
 			     source_p->name, source_p->username,
-			     source_p->host);
+			     source_p->vhost);
       
       sendto_server(client_p, source_p, chptr, CAP_KNOCK, NOCAPS, LL_ICLIENT,
                     ":%s KNOCK %s %s",
@@ -438,14 +438,16 @@
 {
   char src_host[NICKLEN + USERLEN + HOSTLEN + 6];
   char src_iphost[NICKLEN + USERLEN + HOSTLEN + 6];
+  char src_vhost[NICKLEN + USERLEN + HOSTLEN +6];
 
   if(!IsPerson(who))
     return 0;
 
   ircsprintf(src_host,"%s!%s@%s", who->name, who->username, who->host);
   ircsprintf(src_iphost,"%s!%s@%s", who->name, who->username, sockhost);
+  ircsprintf(src_vhost, "%s!%s@%s", who->name, who->username, who->vhost);
 
-  return (check_banned_knock(chptr, who, src_host, src_iphost));
+  return (check_banned_knock(chptr, who, src_host, src_iphost, src_vhost));
 }
 
 /* check_banned_knock()
@@ -459,7 +461,7 @@
  */
 static int
 check_banned_knock(struct Channel *chptr, struct Client *who,
-		   char *s, char *s2)
+		   char *s, char *s2, char *s3)
 {
   dlink_node *ban;
   dlink_node *except;
@@ -470,7 +472,7 @@
   {
     actualBan = ban->data;
 
-    if (match(actualBan->banstr, s) || match(actualBan->banstr, s2))
+    if (match(actualBan->banstr, s) || match(actualBan->banstr, s2) || match(actualBan->banstr, s3))
       break;
     else
       actualBan = NULL;
@@ -482,7 +484,7 @@
     {
       actualExcept = except->data;
 
-      if (match(actualExcept->banstr, s) || match(actualExcept->banstr, s2))
+      if (match(actualExcept->banstr, s) || match(actualExcept->banstr, s2) || match(actualExcept->banstr, s3))
         return CHFL_EXCEPTION;
     }
   }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_list.c PleXusIRCd-1.17a/modules/m_list.c
--- ircd-hybrid-7.0/modules/m_list.c	Fri Jan 17 00:11:53 2003
+++ PleXusIRCd-1.17a/modules/m_list.c	Thu Jul 24 21:26:56 2003
@@ -47,6 +47,7 @@
 static void mo_list(struct Client*, struct Client*, int, char**);
 static int list_all_channels(struct Client *);
 static void list_one_channel(struct Client *,struct Channel *);
+static char modebuf[BUFSIZE], parabuf[BUFSIZE];
 
 struct Message list_msgtab = {
   "LIST", 0, 0, 0, 0, MFLG_SLOW, 0,
@@ -106,7 +107,7 @@
     }
 
   /* If no arg, do all channels *whee*, else just one channel */
-  if (parc < 2 || BadPtr(parv[1]))
+  if (parc < 2 || BadPtr(parv[1]) || parv[1] == NULL)
     {
       list_all_channels(source_p);
     }
@@ -142,7 +143,7 @@
     }
 
   /* If no arg, do all channels *whee*, else just one channel */
-  if (parc < 2 || BadPtr(parv[1]))
+  if (parc < 2 || BadPtr(parv[1]) || parv[1] == NULL)
     {
       list_all_channels(source_p);
     }
@@ -169,7 +170,7 @@
       if(!IsCapable(client_p->from,CAP_LL) && !MyConnect(source_p))
 	return;
 
-      if (parc < 2 || BadPtr(parv[1]))
+      if (parc < 2 || BadPtr(parv[1]) || parv[1] == NULL)
 	{
 	  list_all_channels(source_p);
 	}
@@ -194,10 +195,13 @@
 
   for ( chptr = GlobalChannelList; chptr; chptr = chptr->nextch )
     {
-      if ( !source_p->user ||
-	   (SecretChannel(chptr) && !IsMember(source_p, chptr)))
-	continue;
-      list_one_channel(source_p,chptr);
+      if (IsOper(source_p)) { 
+	list_one_channel(source_p,chptr);
+      } else {
+        if ( !source_p->user || (SecretChannel(chptr) && !IsMember(source_p, chptr)))
+	  continue;
+        list_one_channel(source_p,chptr);
+      }
     }
 
   sendto_one(source_p, form_str(RPL_LISTEND), me.name, source_p->name);
@@ -304,7 +308,15 @@
   else
 #endif
     {
-      sendto_one(source_p, form_str(RPL_LIST), me.name, source_p->name,
+      if (IsOper(source_p)) {
+        *modebuf = *parabuf = '\0';
+        channel_modes(chptr, source_p, modebuf, parabuf);
+       
+          sendto_one(source_p, ":%s 322 %s %s %d :[%s] %s", me.name, source_p->name,
+                 chptr->chname, chptr->users, modebuf, chptr->topic == NULL ? "" : chptr->topic);
+      } else {
+        sendto_one(source_p, ":%s 322 %s %s %d :%s", me.name, source_p->name,
                  chptr->chname, chptr->users, chptr->topic == NULL ? "" : chptr->topic );
+      }
     }
 }
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_lljoin.c PleXusIRCd-1.17a/modules/m_lljoin.c
--- ircd-hybrid-7.0/modules/m_lljoin.c	Thu Jan 16 20:09:59 2003
+++ PleXusIRCd-1.17a/modules/m_lljoin.c	Mon Jun 16 18:15:10 2003
@@ -306,7 +306,7 @@
 		       ":%s!%s@%s JOIN :%s",
 		       target_p->name,
 		       target_p->username,
-		       target_p->host,
+		       target_p->vhost,
 		       root_vchan->chname);
   
   if( flags & CHFL_CHANOP )
diff -uNrd -x ChangeLog ircd-hybrid-7.0/modules/m_map.c PleXusIRCd-1.17a/modules/m_map.c
--- ircd-hybrid-7.0/modules/m_map.c	Wed Dec 31 19:00:00 1969
+++ PleXusIRCd-1.17a/modules/m_map.c	Mon Jun 16 18:47:14 2003
@@ -0,0 +1,159 @@
+/*
+ *  ircd-hybrid: an advanced Internet Relay Chat Daemon(ircd).
+ *  m_map.c: Sends an Undernet compatible map to a user.
+ *
+ *  Copyright (C) 2002 by the past and present ircd coders, and others.
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
+ *  USA
+ *
+ *  $Id: m_map.c,v 1.2 2002/10/15 07:30:08 fishwaldo Exp $
+ */
+
+#include "stdinc.h"
+#include "client.h"
+#include "modules.h"
+#include "handlers.h"
+#include "numeric.h"
+#include "send.h"
+#include "s_conf.h"
+
+#define USER_COL       50 /* display | Users: %d at col 50 */
+
+static void m_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void mo_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[]);
+static void dump_map(struct Client *client_p,struct Client *root, char *pbuf);
+
+struct Message map_msgtab = {
+  "MAP", 0, 0, 0, 0, MFLG_SLOW, 0,
+  {m_unregistered, m_map, m_ignore, mo_map}
+};
+
+#ifndef STATIC_MODULES
+void _modinit(void)
+{
+  mod_add_cmd(&map_msgtab);
+}
+
+void _moddeinit(void)
+{
+  mod_del_cmd(&map_msgtab);
+}
+
+const char *_version = "$Revision: 1.2 $";
+#endif
+
+static char buf[BUFSIZE];
+
+/* m_map
+**	parv[0] = sender prefix
+*/
+static void m_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  if (!ConfigServerHide.flatten_links)
+  {
+    dump_map(client_p,&me,buf);
+    sendto_one(client_p, form_str(RPL_MAPEND), me.name, client_p->name);
+    return;
+  }
+
+  m_not_oper(client_p,source_p,parc,parv);
+  return;
+}
+
+/*
+** mo_map
+**      parv[0] = sender prefix
+*/
+static void mo_map(struct Client *client_p, struct Client *source_p,
+                    int parc, char *parv[])
+{
+  dump_map(client_p,&me,buf);
+  sendto_one(client_p, form_str(RPL_MAPEND), me.name, client_p->name);
+}
+
+/*
+** dump_map
+**   dumps server map, called recursively.
+*/
+static void dump_map(struct Client *client_p,struct Client *root_p, char *pbuf)
+{
+  int cnt = 0, i = 0, len;
+  int users = 0;
+  struct Client *server_p,*user_p;
+        
+  *pbuf= '\0';
+
+  if (root_p->hidden_server && !IsOper(client_p)) {
+  	goto nextserver;
+  }
+  strncat(pbuf,root_p->name,BUFSIZE - ((size_t) pbuf - (size_t) buf));
+  len = strlen(buf);
+  buf[len] = ' ';
+	
+  if (len < USER_COL)
+  {
+     for (i = len+1; i < USER_COL; i++)
+     {
+       buf[i] = '-';
+     }
+  }
+	
+  /* FIXME: add serv->usercnt */
+  for( user_p = root_p->serv->users; user_p; user_p = user_p->lnext )
+    users++;
+        
+  snprintf(buf + USER_COL, BUFSIZE - USER_COL,
+           " | Users: [%5d] (%4.1f%%)", users,
+           100 * (float) users / (float) Count.total);
+        
+  sendto_one(client_p, form_str(RPL_MAP),me.name,client_p->name,buf);
+nextserver:      
+  if ((server_p = root_p->serv->servers))
+  {
+    for (; server_p; server_p = server_p->lnext)
+    {
+      cnt++;
+    }
+    
+    if (cnt)
+    {
+      if (pbuf > buf + 3)
+      {
+        pbuf[-2] = ' ';
+        if (pbuf[-3] == '`')
+          pbuf[-3] = ' ';
+      }
+    }
+  }
+  for (i = 1,server_p = root_p->serv->servers; server_p; server_p=server_p->lnext)
+  {
+    *pbuf = ' ';
+    if ((i < cnt) && (!server_p->lnext->hidden_server && !IsOper(client_p)))
+      *(pbuf + 1) = '|';
+    else
+      *(pbuf + 1) = '`';
+      
+    *(pbuf + 2) = '-';
+    *(pbuf + 3) = ' ';
+    dump_map(client_p,server_p,pbuf+4);
+ 
+    i++;
+   }
+}
+
